<?php
class Rvtech_Starshipit_Model_Carrier_Startrack extends Mage_Shipping_Model_Carrier_Abstract
implements Mage_Shipping_Model_Carrier_Interface {
  protected $_code = 'startrack';

  public function collectRates(Mage_Shipping_Model_Rate_Request $request)
  {
    if (!Mage::getStoreConfig('carriers/'.$this->_code.'/active')) {
      return false;
    }
    	       
    $show = false;
    $price = 0;
    $doCalulate = $this->getConfigData('calculate');
    if ($doCalulate==0) {
      $show = true;
      $price = $this->getConfigData('price');
      
      $result = Mage::getModel('shipping/rate_result');
      $method = Mage::getModel('shipping/rate_result_method');
      $method->setCarrier($this->_code);
      $method->setMethod($this->_code);
      $method->setCarrierTitle($this->getConfigData('title'));
      $method->setMethodTitle($this->getConfigData('name'));
      $method->setPrice($price);
      $method->setCost($price);
      $result->append($method);
    }
    else {
      try {
        $shipItApiKey = Mage::helper('shipnote')->getShipItApiKey();
        if ($shipItApiKey == "") {
          return false;
        }
        
        $origCountryId = $request->getCountryId();  //Package Source Country ID
        $origRegionId = $request->getRegionId();    //Package Source Region ID
        $origRegionCode = $request->getRegion();    //Package Source Region Code
        $origCity = $request->getCity();            //Package Source City
        $origPostcode = $request->getPostcode();    //Package Source Post Code
           
        $destCountryId = $request->getDestCountryId();
        $destCountry = $request->getDestCountry();
        $destRegion = $request->getDestRegionId();
        $destRegionCode = $request->getDestRegionCode();
        $destFullStreet = $request->getDestStreet();
        $destStreet = "";
        $destSuburb = "";
        $destCity = $request->getDestCity();
        $destPostcode = $request->getDestPostcode();
          
        $destFullStreetArray = explode("\n", $destFullStreet);
        if ($destFullStreetArray[0] !== false)
          $destStreet = $destFullStreetArray[0];
        if ($destFullStreetArray[1] !== false)
          $destSuburb = $destFullStreetArray[1];   
          
        $packageValueDiscout = $request->getPackageValueWithDiscount();   //Dest Package Value After Discount
        $packageCurrency = $request->getPackageCurrency();
        
	    $counter = 0;
	    $itemList = '';

        try {
            $cartItems = Mage::getSingleton('checkout/session')->getQuote()->getAllItems();

            if (is_null($cartItems)) {
                $errorMessage = "Checkout item(s) not found";
                throw new \Exception($e->$errorMessage);
            }

	        foreach ($cartItems as $item) {
		        $product = Mage::getModel('catalog/product')->load($item->getProduct()->getId());

                if (is_null($product)) {
                    $errorMessage = "Product with Id ".$product." not found";
                    throw new \Exception($e->$errorMessage);
                }

		        $productName = str_replace('"', '\\"', $product->getName());
		        $productPrice = $product->getPrice();
		        $quantity = $item->getQty();
		        $weight = $product->getWeight();

		        $height = $product->getHeight();
                if (!is_numeric($height)) {
                    $height = 0;        
				}

		        $width = $product->getWidth();
                if (!is_numeric($width)) {
                    $width = 0;        
				}

		        $length = $product->getLength();
		        if (!is_numeric($length)) {
                    $length = 0;        
				}

                $itemList .= '{
                    "name": "' . $productName . '",
                    "sku": null,
                    "quantity": ' . $quantity . ',
                    "grams": ' . $weight . ',
                    "height": ' . $height . ',
                    "width": ' . $width . ',
                    "length": ' . $length . ',
                    "price": ' . $productPrice . ',
                    "vendor": null,
                    "requires_shipping": true,
                    "taxable": true,
                    "fulfillment_service": "manual"
                },';

                if ($counter == count($cartItems) - 1) {
                  $itemList = rtrim($itemList, ',');
                }

                $counter++;
            }
		} catch (Exception $e) {
            $packageValue = $request->getPackageValue(); //Dest Package Value   
            $packageWeight = $request->getPackageWeight() * 1000;             //Package Weight (grams)

            $itemList = '{
              "name": "Total Items",
              "sku": null,
              "quantity": 1,
              "grams": ' . $packageWeight . ' ,
              "price": ' . $packageValue . ',
              "vendor": null,
              "requires_shipping": true,
              "taxable": true,
              "fulfillment_service": "manual"
            }';

            Mage::log($e->getMessage());
		}

        $url = 'https://api2.starshipit.com/rate?apiKey=' . $shipItApiKey . '&integration=magento&format=json';
        $post_data = '{
                        "rate": {
                          "origin": {
                            "country": "' . $origCountryId . '",
                            "postal_code": "' . $origPostcode . '",
                            "province": "' . $origRegionCode . '",
                            "city": "' . $origCity . '",
                            "name": null,
                            "address1": null,
                            "address2": null,
                            "address3": null,
                            "phone": null,
                            "fax": null,
                            "address_type": null,
                            "company_name": null
                          },
                          "destination":{  
                            "country": "' . $destCountryId . '",
                            "postal_code": "' . $destPostcode . '",
                            "province": "' . $destRegionCode . '",
                            "city": "' . $destCity . '",
                            "name": null,
                            "address1": "' . $destStreet . '",
                            "address2": "' . $destSuburb . '",
                            "address3": null,
                            "phone": null,
                            "fax": null,
                            "address_type": null,
                            "company_name": null
                          },
                          "items":[' .
                                "$itemList" .
                          '],
                          "currency": "' . $packageCurrency->getCurrencyCode() . '",
                          "carrierid": "18"
                        }
                      }';
        $contentLength = strlen($post_data);
                            
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_HEADER, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);        
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'));           
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
        $response = curl_exec($ch);
        curl_close($ch);
      
        $json_obj = json_decode($response);
        $rates_obj = $json_obj->{'rates'};
                                 
        $handling = Mage::getStoreConfig('carriers/'.$this->_code.'/handling');
      	$result = Mage::getModel('shipping/rate_result');
      	
        if (sizeof($rates_obj) > 0) {
          $show = true;
        }
        
        if ($show) {
          foreach ($rates_obj as $rate) {
            if (is_object($rate)) {
              // Add shipping option with shipping price
              $method = Mage::getModel('shipping/rate_result_method');
              $method->setCarrier($this->_code);
              $method->setMethod($this->_code . $rate->{'service_code'});
              $method->setCarrierTitle($this->getConfigData('title'));
              $method->setMethodTitle($rate->{'service_name'});
              $method->setPrice($rate->{'total_price'});
              $method->setCost(0);      
              $result->append($method);
            }
          }
        }
        else {
          $error = Mage::getModel('shipping/rate_result_error');
          $error->setCarrier($this->_code);
          $error->setCarrierTitle($this->getConfigData('name'));
          $error->setErrorMessage($this->getConfigData('specificerrmsg'));
          $result->append($error);
        }
      }
      catch (Exception $e) {
        Mage::log($e->getMessage());
      }
    }

    return $result;
  }
  
  public function getAllowedMethods() {
    return array('startrack'=>$this->getConfigData('name'));
  }

  public function isTrackingAvailable() {
    return true;
  }
  
  public function getTrackingInfo($tracking) {
    $status = Mage::getModel('shipping/tracking_result_status');
    $status->setCarrier($this->_code);
    $status->setCarrierTitle($this->getConfigData('title'));
    $status->setTracking($tracking);
    $status->setPopup(1);
    $status->setUrl("http://www.startrack.com.au/track-trace/?id=".$tracking);
    return $status;           
  }  
}
